#!/bin/sh
gDebug=0
# gCodecsinstalled
# gCodecVendor
# gCodecDevice
# gCodecName
# gCodec

# get installed codec/revision
gCodecsInstalled=$(ioreg -rxn IOHDACodecDevice | grep VendorID | awk '{ print $4 }' | sed -e 's/ffffffff//')
gCodecsVersion=$(ioreg -rxn IOHDACodecDevice | grep RevisionID| awk '{ print $4 }')
gVoodooInstalled=$(kextstat | grep VoodooHDA | awk '{ print $2 }')
gCodecVendorID=$(ioreg -rxn IOHDACodecDevice | grep VendorID | awk '{ print $4 }')
if [[ $gVoodooInstalled = 0 ]]; then
	echo Please disable VoodooHDA!
	exit 1
fi

# no codecs detected
if [ -z "${gCodecsInstalled}" ]; then
    echo "No audio codec detected"
    exit 1
fi

# initialize variables
VIA=n
amd=n
nvidia=n
realtek=n
unknown=n
alternate=n

# find realtek codecs
index=0
version=($gCodecsVersion)
for codec in $gCodecsInstalled
do

# sort vendors and devices
case ${codec:2:4} in

    8680 ) Codecintelhdmi=$codec; VIA=y
    ;;
    1002 ) Codecamdhdmi=$codec; amd=y
    ;;
    10de ) Codecnvidiahdmi=$codec; nvidia=y
    ;;
    10ec ) Codecrealtekaudio=$codec; Versionrealtekaudio=${version[$index]}; realtek=y
    ;;
    *) Codecunknownaudio=$codec; unknown=y
    ;;

esac
index=$((index + 1))
done

# special names
if [ $realtek = y ]; then
    gCodecVendor=${Codecrealtekaudio:2:4}
    gCodecDevice=${Codecrealtekaudio:6:4}

# debug
    if [ ${gCodecDevice:0:1} = 0 ]; then
        gCodecName=${gCodecDevice:1:3}
    fi

    if [ $gCodecDevice = "0899" ]; then
        gCodecName=898
    fi

    if [ $gCodecDevice = "0900" ]; then
        gCodecName=1150
    fi

#  validate_realtek codec
    case "$gCodecName" in
		269|255|882|883|885|887|888|889|891|892|898|1150 ) 

# confirm codec, go button
    while true
    do
    read -p "Confirm Realtek ALC$gCodecName (y/n): " choice3
    case "$choice3" in
        [yY]* ) gCodec=$gCodecName; gCodecvalid=y; break;;
        [nN]* ) gCodec=$gCodecName; gCodecinvalid=n; exit; break;;
    * ) echo "Try again...";;
    esac
    done
    ;;

    * ) 
    ;;
    esac
fi
if [ ${gCodecVendorID:2:8} = 1002aa01 ]; then
	cd ~/Downloads/
   	curl -# -O "https://raw.githubusercontent.com/Fredde2209/AppleALC-kexts-for-Bios/master/AppleALC-1.1.1-VT2020:21.zip"
   	unzip -qq AppleALC-*.zip
	rm -r __MACOSX/ AppleALC-*.zip
	echo "The required Data was downloaded succesfully and saved to Your Downloads-Folder!"
	echo 
	echo "Thank's for using Fredde2209's ALC-Downloader!"
elif [ $realtek = y ]; then
	while true
	do
		read -p "Please choose a version: 1.0.19 or 1.1.1 (a/b): " choice4
		echo --------------------------------------------------------------------------------
		case "$choice4" in
			[aA]* ) 
			echo "wait for Download to begin... "
			if [ ${gCodecName} = 255 ] || [ ${gCodecName} = 882 ] || [ ${gCodecName} = 883 ] || [ ${gCodecName} = 885 ] || [ ${gCodecName} = 887 ] || [ ${gCodecName} = 888 ] || [ ${gCodecName} = 889 ] || [ ${gCodecName} = 891 ] || [ ${gCodecName} = 892 ] || [ ${gCodecName} = 898 ] || [ ${gCodecName} = 1150 ]; then
				cd ~/Downloads/
				curl -# -O "https://raw.githubusercontent.com/Fredde2209/AppleALC-kexts-for-Bios/master/AppleALC-$gCodecName.zip"
				unzip -qq AppleALC-*.zip
				rm -r __MACOSX/ AppleALC-*.zip
				echo "The required Data was downloaded succesfully and saved to Your Downloads-Folder!"
				echo 
				echo "Thank's for using Fredde2209's ALC-Downloader!"
			else echo "Your codec is not yet supported! Please contact me at https://hackintosh-forum.de/"
			fi 
			break;;
			[bB]* ) 
			echo "wait for Download to begin... "
			if [ ${gCodecName} = 255 ] || [ ${gCodecName} = 887 ] || [ ${gCodecName} = 892 ] || [ ${gCodecName} = 898 ] || [ ${gCodecName} = 1150 ]; then
				cd ~/Downloads/
 				curl -# -O "https://raw.githubusercontent.com/Fredde2209/AppleALC-kexts-for-Bios/master/AppleALC-1.1.1-$gCodecName.zip"
				unzip -qq AppleALC-*.zip
	 			rm -r __MACOSX/ AppleALC-*.zip
   				echo "The required Data was downloaded succesfully and saved to Your Downloads-Folder!"
   				echo 
   				echo "Thank's for using Fredde2209's ALC-Downloader!"
			else echo "Your codec is not yet supported! Please contact me at https://hackintosh-forum.de/"
			fi
			break;;
			* ) echo "Try again...";;
	esac
	done
fi